@echo off
rem ======================================================================
::
::  compare autoruns
::
rem ----------------------------------------------------------------------
::
::  DE:
::  Dieses Skript ermittelt mit der Freeware autorunsc.exe die Aenderungen
::  in den Autostarts.
::
::  EN:
::  This script uses the freeware autorunsc.exe to find changes
::  in the autostart entries.
::
::  --> autoruns_compare_readme.txt.
::
rem ----------------------------------------------------------------------
::  2005-03-13  1.0  - initialized
::  2005-03-15  1.1  - added username in masterfilename that each user has
::                     its own masterfile
::                   - changed syntax of language file
::  support@axel-hahn.de
rem ======================================================================

rem ----------------------------------------------------------------------
::  CONFIG
rem ----------------------------------------------------------------------

	:: Sprache festlegen/ set language
	set fLangfile=autoruns_compare_de.txt
	:: set fLangfile=autoruns_compare_en.txt

	set fMasterfile=autoruns_master_%username%.txt
	set fTmpfile=%temp%\autoruns_temp_%username%.txt

	rem -----------------------------------------------------------------
	::  do not change below
	rem -----------------------------------------------------------------

	:: parameters for autorunsc
	set sParams=-acdesw

	set sColorWork=78
	set sColorWait=70
	set sColorError=cf
	set sColorOK=a0


rem ----------------------------------------------------------------------
::  MAIN
rem ----------------------------------------------------------------------

	color %sColorWork%
	title AutoRun
	echo.
	echo.
	echo --== AUTORUNS - compare V1.1 ==--
	echo.
	echo.

	rem -----------------------------------------------------------------
	::  test some needed files
	rem -----------------------------------------------------------------
	if exist %fLangfile% goto testautorunsc

	color %sColorError%
	title !!! AutoRun
	echo ERROR - missing file / Datei fehlt:
	echo %fLangfile%
	echo.
	goto end

	:testautorunsc
	if exist autorunsc.exe goto start

	color %sColorError%
	title !!! AutoRun
	call :DisplayInfo MissAutorunsc
	call :DisplayInfo msgPressKey2Exit
	pause >nul
	goto end2


	:start
	if exist %fMasterfile% goto compare

	rem -----------------------------------------------------------------
	::  create a master snapshot
	rem -----------------------------------------------------------------
	:createMaster
	call :DisplayInfo createMasterInfo
	call :DisplayInfo msgPause
	color %sColorWait%
	pause >nul
	color %sColorWork%

	call :DisplayInfo createMasterRun
	autorunsc %sParams% >%fMasterfile% 2>nul
	dir "%fMasterfile%" | find "%fMasterfile%"
	call :DisplayInfo msgDone
	goto end


	rem -----------------------------------------------------------------
	::  get actual settings ...
	rem -----------------------------------------------------------------
	:compare
	call :DisplayInfo compareCollect
	autorunsc %sParams% >%fTmpfile% 2>nul
	call :DisplayInfo msgDone

	rem -----------------------------------------------------------------
	::  ... and compare with master snapshot
	rem -----------------------------------------------------------------
	call :DisplayInfo compareFc
	fc %fTmpfile% %fMasterfile% >nul

	if %ERRORLEVEL%==0 goto compareOK

	color %sColorError%
	title !!! AutoRun
	fc %fTmpfile% %fMasterfile%
	call :DisplayInfo compareWarn

	call :DisplayInfo msgPause
	pause >nul

	start autoruns

	goto end


	:compareOK
	color %sColorOK%
	title OK: AutoRun
	call :DisplayInfo compareOK
	goto end


rem ----------------------------------------------------------------------
::  internal "functions"
rem ----------------------------------------------------------------------

	:DisplayInfo
	FOR /F "delims=: tokens=1* " %%a IN ('findstr "^%1:" %fLangfile%') do cmd /c echo%%b
	goto end2


rem ----------------------------------------------------------------------
::  END OF SCRIPT
rem ----------------------------------------------------------------------

	rem -----------------------------------------------------------------
	:end
	del %fTmpfile% 2>nul
	call :DisplayInfo msgendOfScript
	ping -n 6 localhost >nul

	rem -----------------------------------------------------------------
	:end2


rem ======================================================================
::	eof
rem ======================================================================